package com.xy.service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xy.SysDictService;
import com.xy.annotate.Runners;
import com.xy.collections.list.JArrayList;
import com.xy.collections.list.JList;
import com.xy.entity.SysDict;
import com.xy.entity.SysDictRedis;
import com.xy.mapper.SysDictMapper;
import com.xy.utils.Beans;
import com.xy.utils.RedisService;
import com.xy.utils.SysDictUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 字典表 服务实现类
 * </p>
 *
 * @author lijin
 * @since 2022-12-09
 */
@Slf4j
@Service
@AllArgsConstructor
public class SysDictServiceImpl extends ServiceImpl<SysDictMapper, SysDict> implements SysDictService {

    private RedisService<SysDictRedis> redisService;

    /**
     * 加载字典到redis
     */
    @Runners
    public void loadDataRedis() {
        List<SysDict> sysDicts = list();
        List<SysDictRedis> sysDictRedis = Beans.copy(SysDictRedis.class, sysDicts);
        JList<SysDictRedis> list = new JArrayList<>(sysDictRedis);
        //父字典
        JList<SysDictRedis> paters = list.filter().isNull(SysDictRedis::getPaterCode).list();
        //[父code -> 子列表]数据结构写入redis
        paters.forEach(sysDict -> {
            JList<SysDictRedis> sysDictJList = list.filter().eq(SysDictRedis::getPaterCode, sysDict.getCode()).list();
            sysDictJList.forEach(sysDictRediss -> redisService.setMap(SysDictUtils.getKey(sysDict.getCode()), sysDictRediss.getCode(), sysDictRediss));
        });
        log.info("字典写入redis完成~");
    }

}
